# frozen_string_literal: true

require_relative 'base_object'
require_relative 'path_item_object'

module R2OAS
  module Schema
    module V3
      class TagObject < BaseObject
        def initialize(tags_data, opts = {})
          super(opts)
          @tags_data = tags_data
        end

        def to_doc
          @tags_data.each_with_object([]) do |tag_name, result|
            result.push(create_doc(tag_name))
          end
        end

        private

        def create_doc(tag_name)
          {
            'name' => tag_name,
            'description' => "#{tag_name} description",
            # External Docs Object
            'externalDocs' => {
              'description' => 'description',
              'url' => 'url'
            }
          }
        end
      end
    end
  end
end
